/*
  Few example using template (preliminari part)
*/

#include <iostream>
#include <cmath>
#include <complex>

using namespace std ; // for the moment magic ``keyword''

template <typename T>
unsigned // return the index of the minimum
findMinimum( T a[], unsigned size ) ;

// specialize the code for complex number
template <typename T>
unsigned // return the index of the minimum
findMinimum( complex<T> a[], unsigned size ) ;

// specialize the code for complex number
template <>
unsigned // return the index of the minimum
findMinimum( complex<double> a[], unsigned size ) ;

// specialize the code for complex number
unsigned // return the index of the minimum
findMinimum( complex<double> a[], unsigned size ) ;

/*
{
  cout << "Calling version 4\n" ;
  unsigned imin = 0 ;
  for ( unsigned i = 1 ; i < size ; ++i )
    if ( std::abs(a[i]) < std::abs(a[imin]) ) imin = i ;
  return imin ;
}
*/

int
main( /* no argument for the moment */ ) {
  double a[] = {2,-3,1,2,-9,8} ;  ;
  unsigned ipos = findMinimum( a, sizeof(a)/sizeof(a[0]) ) ;
  cout << "minimum is " << a[ipos] << " at position " << ipos << '\n' ;

  complex<double> b[] = { complex<double>(1,3),
                          complex<double>(0,1),
                          complex<double>(-2,0),
                          complex<double>(1,3),
                          complex<double>(1.2,0) } ;
  ipos = findMinimum( b, sizeof(b)/sizeof(b[0]) ) ;
  cout << "minimum is " << b[ipos] << " at position " << ipos << '\n' ;
  return 0 ; // return 0 to the OS
}
