/*
  Few example using template (preliminari part)
*/

#include <iostream>
#include <cmath>
#include <complex>

using namespace std ; // for the moment magic ``keyword''
using namespace std ; // for the moment magic ``keyword''

template <typename T>
unsigned // return the index of the minimum
findMinimum( T a[], unsigned size ) {
  cout << "Calling version 1\n" ;
  unsigned imin = 0 ;
  for ( unsigned i = 1 ; i < size ; ++i )
    if ( a[i] < a[imin] ) imin = i ;
  return imin ;
}

// specialize the code for complex number
template <typename T>
unsigned // return the index of the minimum
findMinimum( complex<T> a[], unsigned size ) {
  cout << "Calling version 2\n" ;
  unsigned imin = 0 ;
  for ( unsigned i = 1 ; i < size ; ++i )
    if ( std::abs(a[i]) < std::abs(a[imin]) ) imin = i ;
  return imin ;
}

// specialize the code for complex number
template <>
unsigned // return the index of the minimum
findMinimum( complex<double> a[], unsigned size ) {
  cout << "Calling version 3\n" ;
  unsigned imin = 0 ;
  for ( unsigned i = 1 ; i < size ; ++i )
    if ( std::abs(a[i]) < std::abs(a[imin]) ) imin = i ;
  return imin ;
}

// specialize the code for complex number
unsigned // return the index of the minimum
findMinimum( complex<double> a[], unsigned size )
{
  cout << "Calling version 4\n" ;
  unsigned imin = 0 ;
  for ( unsigned i = 1 ; i < size ; ++i )
    if ( std::abs(a[i]) < std::abs(a[imin]) ) imin = i ;
  return imin ;
}

// explicit instantiation
template unsigned findMinimum( complex<double> a[], unsigned size ) ;
template unsigned findMinimum( double a[], unsigned size ) ;
template unsigned findMinimum( int a[], unsigned size ) ;
template unsigned findMinimum( float a[], unsigned size ) ;
template unsigned findMinimum( short a[], unsigned size ) ;

