/*
 * Matrix Matrix multiplication routine
 */

#include <iostream>
#include <iomanip>

#include "mm.hh"
#define A(I,J) A[(I)+(J)*ldA]

using namespace std ;

void
mm_print( double const A[],
          unsigned     ldA,
          unsigned     n_row,
          unsigned     n_col ) {
  for ( unsigned i = 0 ; i < n_row ; ++i ) {
    cout << A(i,0) ;
    for ( unsigned j = 1 ; j < n_col ; ++j )
      cout << " " << setw(10) << A(i,j) ; // setw reserve 10 space for the next output
    cout << '\n' ;
  }
}