#include <iostream>
#include <iomanip>
#include <cstdlib> // near equivalent to <stdlib.h>  for exit, rand, ...
#include <cmath>   // near equivalent to <math.h>    for sin, cos, log, ..
#include "mm.hh"

#define A(I,J) A[(I)+(J)*ldA]
#define B(I,J) B[(I)+(J)*ldB]
#define C(I,J) C[(I)+(J)*ldC]

using namespace std ;

int
main() {
  
  double A[9] = { 1,2,3,    // first column
                  4,5,6,    // second column
                  7,8,9 } ; // third column
  double B[] = { 1,2,0,    // first column
                 0,0,1,    // second column
                 1,2,1} ;  // third column
  double C[100] ; 

  cout << "Matrix A\n" ;
  mm_print( A, 3, 3, 3 ) ;
  cout << "Matrix B\n" ;
  mm_print( B, 3, 3, 3 ) ;

  mm_standard( A, 3,
               B, 3,
               C, 3,
               3, 3, 3 ) ;

 cout << "Matrix C = A*B\n" ;
 mm_print( C, 3, 3, 3 ) ;

}
